﻿using static System.Runtime.InteropServices.JavaScript.JSType;
using System;

namespace SimpleArrays {
	internal class Program {
		static void Set(ref int target, int value) {
			target = value;
		}

		static void Main(string[] args) {
			int[] a1 = new int[3];
			a1[0] = 20;
			Set(ref a1[1], 10);

			for (int i = 0; i < a1.Length; i++) {
				Console.WriteLine(a1[i]);
            }
            Console.WriteLine();

			List<int> l1 = new List<int>();
			l1.Add(20);
			// Error: A non ref-returning property or indexer may not be used as an out or ref value
			// Set(ref l1[1], 10);

			// Note: Typically not such a good idea:
            Array x = a1;
			object? o = x.GetValue(1);	// Boxing inside
			if (o is null) {
				Console.WriteLine("o is null");
			} else {
				Console.WriteLine($"o.GetType(): {o.GetType()}, o.ToString(): {o.ToString()}");
			}
			Console.WriteLine();

			// Note: Don't be afraid to use static methods on Array:
			Array.Sort(a1);
			for (int i = 0; i < a1.Length; i++) {
				Console.WriteLine(a1[i]);
			}
			Console.WriteLine();
		}
	}
}
