﻿using System.Runtime.Intrinsics.X86;
using static System.Runtime.InteropServices.JavaScript.JSType;

namespace StructConstructorInArray {

	struct S1 {
		public int X;
		public int Y;
		public int Z { get; set; }

		public S1() {
			Console.WriteLine("S1 .ctor");
		}
	}

	internal class Program {
		static void Main(string[] args) {
			Console.WriteLine(">>> a1 >>>");

			S1 a1;
			// Error: Use of possibly unassigned field 'X'
			// Console.WriteLine(a1.X);
			a1 = new S1();
			Console.WriteLine(a1.X);

			Console.WriteLine(">>> b1 >>>");

			S1 b1;
			b1.X = 11;
			// Error: Use of unassigned local variable 'b1'
			// b1.Z = 22;
			Console.WriteLine(b1.X);

			// Error: Use of unassigned local variable 'b1'
			// S1 c1 = b1;

			Console.WriteLine(">>> a3 >>>");

			S3 a3 = new S3();
			Console.WriteLine(a3.X);
			Console.WriteLine(a3.Y);

			Console.WriteLine(">>> b3 >>>");

			S3 b3;
			b3.X = 33;
			Console.WriteLine(b3.X);
			// Error: Use of possibly unassigned field 'Y'
			// Console.WriteLine(b3.Y);

			Console.WriteLine(">>> c3 >>>");

			S3 c3 = default(S3);
			Console.WriteLine(c3.X);
			Console.WriteLine(c3.Y);

			Console.WriteLine(">>> d3 >>>");

			S3 d3 = default;
			Console.WriteLine(d3.X);
			Console.WriteLine(d3.Y);

			Console.WriteLine("-------");

			Console.WriteLine(">>> S1[] >>>");

			S1[] array1 = new S1[4];
			Console.WriteLine(array1[0].X);
			Console.WriteLine(array1[0].Y);

			Console.WriteLine(">>> S3[] >>>");

			S3[] array3 = new S3[4];
			Console.WriteLine(array3[0].X);
			Console.WriteLine(array3[0].Y);

			Console.WriteLine(">>> C1 >>>");

			C1 c1 = new C1();
            Console.WriteLine(c1.Value1.X);
			Console.WriteLine(c1.Value3.X);

			Console.WriteLine(">>> C2 >>>");

			C2 c2 = new C2();
			Console.WriteLine(c2.Value1.X);
			Console.WriteLine(c2.Value3.X);
		}
	}

	// Error: A 'struct' with field initializers must include an explicitly declared constructor.
	// struct S2 {
	//		public int X = 42;
	// }

	struct S3 {
		public int X = 123;
		public int Y = 42;

		public S3() { }
	}

	class C1 {
		public S1 Value1;
		public S3 Value3;
	}

	class C2 {
		public S1 Value1 = new S1();
		public S3 Value3 = new S3();
	}
}