﻿namespace GotoLabelsAndSwitchCore {
	class Program {
		static void Main(string[] args) {

			for (int y = 0; y < 5; y++) {
				for (int x = 5; x > 0; x--) {
					Console.Write($"y:{y},x:{x} ");
					if (x == y) break;
				}
				Console.WriteLine();
			}
			Console.WriteLine();

			//
			//

			for (int y = 0; y < 5; y++) {
				for (int x = 5; x > 0; x--) {
					Console.Write($"y:{y},x:{x} ");
					if (x == y) goto AfterYLoop;
				}
				Console.WriteLine();
			}
		AfterYLoop:
			Console.WriteLine();

			//
			//

			// Wikipedia: Example: coin-operated turnstile
			// https://en.wikipedia.org/wiki/Finite-state_machine
			// https://en.wikipedia.org/wiki/Finite-state_machine#/media/File:Turnstile_state_machine_colored.svg
			// Valid @ 2022.06.12
			// Current State	Input	Next State	Output
			// Locked			coin    Unlocked	Unlocks the turnstile so that the customer can push through.
			//					push	Locked		None
			// Unlocked			coin	Unlocked	None
			//					push	Locked		When the customer has pushed through, locks the turnstile.

			Console.Write("Press ENTER to continue ...");
			Console.ReadLine();
			Console.WriteLine();
			{
				string ops = "PCPPCCPX";
				int current = 0;
				char op;

			Locked:
				op = ops[current++];
				if (op == 'P') {
					Console.WriteLine("Push -> BLOCKED");
					goto Locked;
				} else if (op == 'C') {
					Console.WriteLine("Coin -> unlocking");
					goto Unlocked;
				} else {
					Console.WriteLine("UNKNOWN OPERATION");
					goto Shutdown;
				}

			Unlocked:
				op = ops[current++];
				if (op == 'P') {
					Console.WriteLine("Push -> PERSON ENTERED -> locking");
					goto Locked;
				} else if (op == 'C') {
					Console.WriteLine("Coin -> coin wasted, still unlocked");
					goto Unlocked;
				} else {
					Console.WriteLine("UNKNOWN OPERATION");
					goto Shutdown;
				}

			Shutdown:
				Console.WriteLine("Shutting down.");
			}

			Console.WriteLine();
			Console.Write("Press ENTER to continue ...");
			Console.ReadLine();
			Console.WriteLine();

			{
				string ops = "PCPPCCPX";
				int current = 0;
				char op;
				State state = State.Locked;

				switch (state) {
					case State.Locked:
						op = ops[current++];
						if (op == 'P') {
							Console.WriteLine($"{state} Push -> BLOCKED");
							goto case State.Locked;
						} else if (op == 'C') {
							Console.WriteLine($"{state} Coin -> unlocking");
							goto case State.Unlocked;
						} else {
							Console.WriteLine($"{state} UNKNOWN OPERATION");
							goto case State.Shutdown;
						}

					case State.Unlocked:
						op = ops[current++];
						if (op == 'P') {
							Console.WriteLine($"{state} Push -> PERSON ENTERED -> locking");
							goto case State.Locked;
						} else if (op == 'C') {
							Console.WriteLine($"{state} Coin -> coin wasted, still unlocked");
							goto case State.Unlocked;
						} else {
							Console.WriteLine($"{state} UNKNOWN OPERATION");
							goto case State.Shutdown;
						}

					case State.Shutdown:
						Console.WriteLine($"{state} Shutting down.");
						break;
				}
			}

			Console.WriteLine();

			{
				string ops = "PCPPCCPX";
				int current = 0;
				char op;
				State state = State.Locked;

				switch (state) {
					case State.Locked:
						state = State.Locked;
						op = ops[current++];
						if (op == 'P') {
							Console.WriteLine($"{state} Push -> BLOCKED");
							goto case State.Locked;
						} else if (op == 'C') {
							Console.WriteLine($"{state} Coin -> unlocking");
							goto case State.Unlocked;
						} else {
							Console.WriteLine($"{state} UNKNOWN OPERATION");
							goto case State.Shutdown;
						}

					case State.Unlocked:
						state = State.Unlocked;
						op = ops[current++];
						if (op == 'P') {
							Console.WriteLine($"{state} Push -> PERSON ENTERED -> locking");
							goto case State.Locked;
						} else if (op == 'C') {
							Console.WriteLine($"{state} Coin -> coin wasted, still unlocked");
							goto case State.Unlocked;
						} else {
							Console.WriteLine($"{state} UNKNOWN OPERATION");
							goto case State.Shutdown;
						}

					case State.Shutdown:
						state = State.Shutdown;
						Console.WriteLine($"{state} Shutting down.");
						break;
				}
			}
		}

		enum State { Locked, Unlocked, Shutdown };
	}

}