﻿using static System.Runtime.InteropServices.JavaScript.JSType;
using System.Linq.Expressions;
using System.Text.RegularExpressions;

namespace SwitchExpressionPatternMatching {

	internal class Program {

		static int f(int? x) {
			int result = x switch {
				> 10 and < 20 => 1000,
				int b => b + 10,
				null => -1
			};

			Console.WriteLine(result);
			// Error: The name 'b' does not exist in the current context
			// Console.WriteLine(b);

			return result;
		}

		static int f2(int? x)
			=> x switch {
				> 10 and < 20 => 1000,
				int b => b + 10,
				null => -1
			};

		static int f3(int? x)
			=> x switch {
				> 10 and < 20 => 1000,
				int b => b + 10,
				_ => -1
			};

		static int f4(int? x)
			=> x switch {
				int b => b + 10,
				// Error: The pattern is unreachable. It has already been handled by a previous arm of the switch expression or it is impossible to match.
				// > 10 and < 20 => 1000,
				_ => -1
			};

		static string f5(int? x)
			=> x switch {
				> 10 => $"{x} is > 10",
				< 20 => $"{x} is < 20",
				_ => $"x is weird"
			};

		static string f6(int? x)
			=> x switch {
				< 20 => $"{x} is < 20",
				> 10 => $"{x} is > 10",
				_ => $"x is weird"
			};

		static void Main(string[] args) {
			_ = f(15);
			_ = f(2);
			_ = f(null);

            Console.WriteLine();

			Console.WriteLine(f2(15));
			Console.WriteLine(f2(2));
			Console.WriteLine(f2(null));

            Console.WriteLine();

            Console.WriteLine(f3(15));
			Console.WriteLine(f3(2));
			Console.WriteLine(f3(null));

			Console.WriteLine();

			Console.WriteLine(f4(15));
			Console.WriteLine(f4(2));
			Console.WriteLine(f4(null));

			Console.WriteLine();

			Console.WriteLine(f5(5));
			Console.WriteLine(f5(15));
			Console.WriteLine(f5(25));
			Console.WriteLine(f5(null));

			Console.WriteLine();

			Console.WriteLine(f6(5));
			Console.WriteLine(f6(15));
			Console.WriteLine(f6(25));
			Console.WriteLine(f6(null));
		}
	}
}
